'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Tower = require('./Tower');

var _Tower2 = _interopRequireDefault(_Tower);

var _AbilityMakers = require('./abilities/AbilityMakers');

var _AbilityMakers2 = _interopRequireDefault(_AbilityMakers);

var _UnitMakers = require('./units/UnitMakers');

var _UnitMakers2 = _interopRequireDefault(_UnitMakers);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TowerLoader = function () {
  function TowerLoader() {
    _classCallCheck(this, TowerLoader);

    this._tower = new _Tower2.default();
  }

  _createClass(TowerLoader, [{
    key: 'load',
    value: function load(towerConfig) {
      var abilities = towerConfig.abilities;
      var warrior = towerConfig.warrior;
      var units = towerConfig.units;


      this._loadAbilities(abilities);
      this._loadWarrior(warrior);
      this._loadUnits(units);

      return this._tower;
    }
  }, {
    key: '_loadAbilities',
    value: function _loadAbilities(abilities) {
      var _this = this;

      abilities.forEach(function (_ref) {
        var name = _ref.name;
        var type = _ref.type;

        var init = _objectWithoutProperties(_ref, ['name', 'type']);

        if (!(type in _AbilityMakers2.default)) {
          throw new Error('Unknown ability type \'' + type + '.\'');
        }

        _this._tower.abilities[name] = _AbilityMakers2.default[type](init);
      });
    }
  }, {
    key: '_loadWarrior',
    value: function _loadWarrior(init) {
      this._tower.units.warrior = _UnitMakers2.default.warrior(init);
    }
  }, {
    key: '_loadUnits',
    value: function _loadUnits(units) {
      var _this2 = this;

      units.forEach(function (_ref2) {
        var name = _ref2.name;
        var type = _ref2.type;

        var init = _objectWithoutProperties(_ref2, ['name', 'type']);

        if (!(type in _UnitMakers2.default)) {
          throw new Error('Unknown unit type \'' + type + '.\'');
        }

        _this2._tower.units[name] = _UnitMakers2.default[type](name, init);
      });
    }
  }]);

  return TowerLoader;
}();

exports.default = TowerLoader;