'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = makeAreaAttack;

var _directions = require('../../constants/directions');

var _Action2 = require('./Action');

var _Action3 = _interopRequireDefault(_Action2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SURROUNDINGS = [[1, 1], [1, -1], [2, 0], [0, 0]];

function makeAreaAttack(_ref) {
  var power = _ref.power;
  var powerLoss = _ref.powerLoss;

  return function (_Action) {
    _inherits(AreaAttack, _Action);

    function AreaAttack() {
      _classCallCheck(this, AreaAttack);

      return _possibleConstructorReturn(this, Object.getPrototypeOf(AreaAttack).apply(this, arguments));
    }

    _createClass(AreaAttack, [{
      key: 'perform',
      value: function perform() {
        var _this2 = this;

        var direction = arguments.length <= 0 || arguments[0] === undefined ? _directions.FORWARD : arguments[0];

        this._verifyDirection(direction);

        if (this._unit.isAlive()) {
          // TODO: Figure out what to say
          this._unit.say('detonates a bomb ' + direction + ' launching a deadly explosion');

          var targetSpace = this._getSpace(direction, 1, 0);
          this._bomb(targetSpace, power);

          SURROUNDINGS.map(function (_ref2) {
            var _ref3 = _slicedToArray(_ref2, 2);

            var x = _ref3[0];
            var y = _ref3[1];
            return _this2._getSpace(direction, x, y);
          }).forEach(function (surroundingSpace) {
            return _this2._bomb(surroundingSpace, power * powerLoss);
          });
        }
      }
    }, {
      key: '_bomb',
      value: function _bomb(space, damageAmount) {
        var receiver = space.unit;
        if (receiver) {
          // TODO: Figure out triggers
          // if ('explode' in receiver.abilities) {
          // receiver.say('caught in bomb\'s flames which detonates ticking explosive');

          // receiver.abilities.explode.perform();
          // } else {
          this._damage(receiver, damageAmount);
          // }
        }
      }
    }]);

    return AreaAttack;
  }(_Action3.default);
}