'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = makeAttack;

var _lodash = require('lodash.range');

var _lodash2 = _interopRequireDefault(_lodash);

var _directions = require('../../constants/directions');

var _Action2 = require('./Action');

var _Action3 = _interopRequireDefault(_Action2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function makeAttack(_ref) {
  var range = _ref.range;
  var power = _ref.power;

  return function (_Action) {
    _inherits(Attack, _Action);

    function Attack() {
      _classCallCheck(this, Attack);

      return _possibleConstructorReturn(this, Object.getPrototypeOf(Attack).apply(this, arguments));
    }

    _createClass(Attack, [{
      key: 'perform',
      value: function perform() {
        var direction = arguments.length <= 0 || arguments[0] === undefined ? _directions.FORWARD : arguments[0];

        this._verifyDirection(direction);

        var receiver = this._getUnits(direction)[0];
        if (receiver) {
          this._unit.say('attacks ' + direction + ' and hits ' + receiver);

          var revisedPower = direction === _directions.BACKWARD ? Math.ceil(power / 2.0) : power;
          this._damage(receiver, revisedPower);
        } else {
          this._unit.say('attacks ' + direction + ' and hits nothing');
        }
      }
    }, {
      key: '_getUnits',
      value: function _getUnits(direction) {
        var _this2 = this;

        return (0, _lodash2.default)(1, range + 1).map(function (offset) {
          return _this2._getUnit(direction, offset);
        }).filter(function (unit) {
          return unit;
        });
      }
    }]);

    return Attack;
  }(_Action3.default);
}