'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = makeMelee;

var _directions = require('../constants/directions');

var _AbilityMakers = require('../abilities/AbilityMakers');

var _AbilityMakers2 = _interopRequireDefault(_AbilityMakers);

var _Unit2 = require('./Unit');

var _Unit3 = _interopRequireDefault(_Unit2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function makeMelee(name, _ref) {
  var maxHealth = _ref.maxHealth;
  var power = _ref.power;

  return function (_Unit) {
    _inherits(Melee, _Unit);

    function Melee() {
      _classCallCheck(this, Melee);

      var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Melee).call(this));

      _this._name = name;
      _this._maxHealth = maxHealth;


      var Attack = _AbilityMakers2.default.attack({ range: 1, power: power });
      _this.addAbility('attack', new Attack());

      var Recon = _AbilityMakers2.default.recon({ range: 1 });
      _this.addAbility('recon', new Recon());
      return _this;
    }

    _createClass(Melee, [{
      key: 'playTurn',
      value: function playTurn(turn) {
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = _directions.RELATIVE_DIRECTION_ARRAY[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var direction = _step.value;

            if (this._isPlayerWithinReach(turn, direction)) {
              turn.attack(direction);
              break;
            }
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }
      }
    }, {
      key: '_isPlayerWithinReach',
      value: function _isPlayerWithinReach(turn, direction) {
        return turn.recon(direction).isPlayer();
      }
    }]);

    return Melee;
  }(_Unit3.default);
}